## public interface JalviewJSApi

# full list of available methods (from JalviewLiteJsApi):

  public boolean addPdbFile(AlignFrame alFrame, String sequenceId, String pdbEntryString, String pdbFile);
  public String getAlignment(String format);
  public String getAlignment(String format, String suffix);
  public String getAlignmentFrom(AlignFrame alf, String format);
  public String getAlignmentFrom(AlignFrame alf, String format, String suffix);
  public String getAlignmentOrder();
  public String getAlignmentOrderFrom(AlignFrame alf);
  public String getAlignmentOrderFrom(AlignFrame alf, String sep);
  public String getAnnotation();
  public String getAnnotationFrom(AlignFrame alf);
  public Object getAppletParameter(String name, boolean asString);
  public URL getCodeBase();
  public URL getDocumentBase();
  public String getFeatureGroups();
  public String getFeatureGroupsOfState(boolean visible);
  public String getFeatureGroupsOfStateOn(AlignFrame alf, boolean visible);
  public String getFeatureGroupsOn(AlignFrame alf);
  public String getFeatures(String format);
  public String getFeaturesFrom(AlignFrame alf, String format);
  public Object getFrameForSource(VamsasSource source);
  public jalview.renderer.seqfeatures.FeatureRenderer getNewFeatureRenderer(AlignViewportI vp);
  public String getParameter(String name);
  public String getSelectedSequences();
  public String getSelectedSequences(String sep);
  public String getSelectedSequencesAsAlignment(String format, String suffix);
  public String getSelectedSequencesAsAlignmentFrom(AlignFrame alf, String format, String suffix);
  public String getSelectedSequencesFrom(AlignFrame alf);
  public String getSelectedSequencesFrom(AlignFrame alf, String sep);
  public Object[] getSelectionForListener(SequenceGroup seqsel, ColumnSelection colsel, HiddenColumns hidden, SelectionSource source, Object alignFrame);
  public String getSeparator();
  public AlignViewportI getViewport();
  public void highlight(String sequenceId, String position, String alignedPosition);
  public void highlightIn(AlignFrame alf, String sequenceId, String position, String alignedPosition);
  public AlignFrame loadAlignment(String text, String title);
  public void loadAnnotation(String annotation);
  public void loadAnnotationFrom(AlignFrame alf, String annotation);
  public void loadFeatures(String features, boolean autoenabledisplay);
  public boolean loadFeaturesFrom(AlignFrame alf, String features, boolean autoenabledisplay);
  public boolean loadScoreFile(String sScoreFile) throws IOException;
  public void newFeatureSettings();
  public void newStructureView(PDBEntry pdb, SequenceI[] seqs, String[] chains, DataSourceType protocol);
  public Object openPcaPanel(AlignFrame af, String modelName);
  public Object openTreePanel(AlignFrame af, String treeType, String modelName);
  public String orderAlignmentBy(AlignFrame alf, String order, String undoName, String sep);
  public String orderBy(String order, String undoName);
  public String orderBy(String order, String undoName, String sep);
  public Object parseArguments(String[] args);
  public boolean parseFeaturesFile(String param, DataSourceType protocol);
  public void removeSelectionListener(AlignFrame af, String listener);
  public void scrollViewToColumnIn(AlignFrame alf, String leftHandColumn);
  public void scrollViewToIn(AlignFrame alf, String topRow, String leftHandColumn);
  public void scrollViewToRowIn(AlignFrame alf, String topRow);
  public void select(String sequenceIds, String columns);
  public void select(String sequenceIds, String columns, String sep);
  public void selectIn(AlignFrame alf, String sequenceIds, String columns);
  public void selectIn(AlignFrame alf, String sequenceIds, String columns, String sep);
  public void setFeatureGroupState(String groups, boolean state);
  public void setFeatureGroupState(String[] groups, boolean state);
  public void setFeatureGroupStateOn(AlignFrame alf, String groups, boolean state);
  public void setSelectionListener(AlignFrame af, String listener);
  public void setSelectionListener(String listener);
  public void setSeparator(String separator);
  public void showOverview();
  public void updateForAnnotations();

# addition available methods (from JalviewLite):

  public static String getBuildDate()
  public static String getInstallation()
  public static String getVersion()



# proposed alias list:
 
- remove overloaded methods
- indicate null options
- use standard arrays; no need for special separators
- possibly return more actual objects, not just strings
 
  public boolean addPdbFile(AlignFrame alFrame, String sequenceId, String pdbEntryString, String pdbFile);
  public String getAlignment(AlignFrame alf, String format, boolean includeStartEnd);
  public String[] getAlignmentOrder(AlignFrame alf);
  public String getAnnotation(AlignFrame alf);
  public Object getAppletParameter(String name, boolean asString);
  public URL getCodeBase();
  public URL getDocumentBase();
  public String[] getFeatureGroups();
  public String[] getFeatureGroupsOfState(boolean visible);
  public String getFeatures(AlignFrame alf, String format);
  public jalview.renderer.seqfeatures.FeatureRenderer getNewFeatureRenderer(AlignViewportI vp);
  public String getParameter(String name);
  public String[] getSelectedSequences(AlignFrame alf);
  public String[] getSelectedSequencesAsAlignment(AlignFrame alf, String format, boolean includeStartEnd);
  public Object[] getSelectionForListener(SequenceGroup seqsel, ColumnSelection colsel, HiddenColumns hidden, SelectionSource source, Object alignFrame);
  public AlignViewportI getViewport();
  public void highlight(AlignFrame alf, String sequenceId, String position, String alignedPosition);
  public AlignFrame loadAlignment(String text, String title);
  public void loadAnnotation(AlignFrame alf, String annotation);
  public boolean loadFeatures(AlignFrame alf, String features, boolean autoenabledisplay);
  public boolean loadScoreFile(String sScoreFile) throws IOException;
  public void newFeatureSettings();
  public void newStructureView(PDBEntry pdb, SequenceI[] seqs, String[] chains, DataSourceType protocol);
  public Object openPcaPanel(AlignFrame af, String modelName);
  public Object openTreePanel(AlignFrame af, String treeType, String modelName);
  public String[] orderBy(AlignFrame alf, String order, String undoName);
  public Object parseArguments(String[] args);
  public boolean parseFeaturesFile(String param, DataSourceType protocol);
  public void removeSelectionListener(AlignFrame af, String listener);
  public void scrollViewTo(AlignFrame alf, String topRow, String leftHandColumn);
  public void select(AlignFrame alf, String[] sequenceIds, String[] columns);
  public void setFeatureGroupState(AlignFrame alf, String groups, boolean state);
  public void setSelectionListener(AlignFrame af, String listener);
  public void showOverview();
  public void updateForAnnotations();

# unknown methods/shouldn't be in interface?

  public Object getFrameForSource(VamsasSource source);
  public void setSeparator(String separator);
  